Crafty.c "WatchKeys",
	###
		Keeps track of which keys are currently pressed
	###
	_current_keys:{}
	init: ->
		@bind "KeyDown", (e) ->
			@_current_keys[e.key] = true
		@bind "KeyUp", (e) ->
			delete @_current_keys[e.key]
	KeyActive: (num)->
		@_current_keys[num]

Crafty.c "Velocity",
	###
		Provides entity with a vecctor2D that is applied to object position.
		_clamp sets the maximum length of this
	###
	_clamp: 7
	init: ->
		console.log 'Velocity component init'
		@v = new window.Vector2
		@bind "EnterFrame", (e) ->
			if window.paused isnt 1
				if @v.length() > @_clamp
					@v = @v.normalize()
					@v = @v.scale(@_clamp)
				@x += @v.x
				@y += @v.y
		this


Crafty.c "Gravity",
	
	_amount: .3
	init: ->
		if window.paused isnt 1

			@requires "Velocity"
			@bind "EnterFrame", (e) ->
				if @wings
					@v.y += .1
				else

					@v.y += @_amount


Crafty.c "Wings",
	init: ->
		if 'FLY : W - S' in window.powers
			@destroy()	
Crafty.c "Jump",
	init: ->
		if 'DOUBLE JUMP' in window.powers
			@destroy()	


