class Vector2
  constructor: (@x=0, @y=0) ->
  add:(vector) -> new Vector2(@x + vector.x, @y + vector.y)
  sub:(vector) -> new Vector2(@x - vector.x, @y - vector.y)
  scale:(factor) -> new Vector2(@x * factor, @y * factor)
  length:() -> Math.sqrt(@x * @x + @y * @y)
  normalize:() -> new Vector2(@x / @.length(), @y / @.length())
  perp:() -> new  Vector2(-@y, @x)

window.Vector2 = Vector2